include asmdasm.inc
.code
SendOut proc <4> pText:QWORD
	mov pText,rcx
	invoke GetWindowTextLength,hMainEdit
	invoke SendMessage,hMainEdit,EM_SETSEL,rax,rax
	invoke SendMessage,hMainEdit,EM_REPLACESEL,FALSE,pText	
	ret
SendOut endp
startproc WinMain
WinMain proc <12>
LOCAL msgs:MSG
	call breakpoint
;	invoke AsmTest64,addr dmnem,addr TstMnem
;	.if eax
;		invoke MessageBox,0,addr dmnem,0,0
;	.endif
	invoke RegisterClassEx, addr wcex
	mov r10,CW_USEDEFAULT
	invoke CreateWindowEx,rbx,addr ClassName,addr AppName,WS_OVERLAPPEDWINDOW or WS_VISIBLE,r10,r10,r10,r10,rbx,rbx,hInstance,rbx
	lea rdi,msgs
	.while TRUE
		invoke GetMessage,rdi,rbx,rbx,rbx
		.break .if ~rax
		invoke TranslateMessage,rdi
		invoke DispatchMessage,rdi
	.endw
	mov rax,[rdi][MSG.wParam]
	invoke ExitProcess,rax
WinMain endp
WndProc proc <12> hWnd:QWORD,uMsg:QWORD,wParam:QWORD,lParam:QWORD
RESERV hWin dq ?
RESERV hShowList16 dq ?
RESERV hShowList32 dq ?
RESERV hShowList64 dq ?
RESERV hEdit16 dq ?
RESERV hEdit32 dq ?
RESERV hEdit64 dq ?
RESERV hSmm dq ?
RESERV hMainEdit dq ?
RESERV hClear dq ?
RESERV hMnemEdit dq ?
RESERV hFont dq ?
RESERV rects RECT {}
RESERV FileName db MAX_PATH dup(?)
CONSTANT Mnem16 db 'xor [bp+si+0AE45h],di',0
CONSTANT Mnem32 db 'cmpxchg8b qword ptr [eax+8*ebp]',0
CONSTANT Mnem64 db 'shrd [eax],esp,cl',0
CONSTANT Clearing db 'Clear screen',0
CONSTANT Dasm16 db 'Disassemble16',0
CONSTANT Dasm32 db 'Disassemble32',0
CONSTANT Dasm64 db 'Disassemble64',0
CONSTANT LTexti db 'instr. length ',0
	.if edx==WM_COMMAND
		.if r9==hShowList16
			invoke GetWindowText,hEdit16,addr mnem,sizeof mnem
			invoke AsmTest16,addr dmnem,addr mnem
			invoke SendOut,addr dmnem
			.if ERFlags
				invoke SendOut,addr RFlags
				invoke SendOut,addr ERFlags
			.endif
		.elseif r9==hShowList32
			invoke GetWindowText,hEdit32,addr mnem,sizeof mnem
			invoke AsmTest32,addr dmnem,addr mnem
			invoke SendOut,addr dmnem
			.if ERFlags
				invoke SendOut,addr RFlags
				invoke SendOut,addr ERFlags
			.endif
		.elseif r9==hShowList64
			invoke GetWindowText,hEdit64,addr mnem,sizeof mnem
			invoke AsmTest64,addr dmnem,addr mnem
			invoke SendOut,addr dmnem
			.if ERFlags
				invoke SendOut,addr RFlags
				invoke SendOut,addr ERFlags
			.endif
		.elseif r9==hClear
			mov ERFlags,NULL
			invoke SetWindowText,hMainEdit,addr ERFlags
		.endif
	.elseif edx==WM_SHOWWINDOW
		mov hWin,rcx
		invoke CreateWindowEx,0,addr button,addr Dasm16,WS_VISIBLE or WS_CHILD,30,15,130,25,hWin,0,hInstance,0
		mov hShowList16,rax
		invoke CreateWindowEx,0,addr button,addr Dasm32,WS_VISIBLE or WS_CHILD,30,45,130,25,hWin,0,hInstance,0
		mov hShowList32,rax
		invoke CreateWindowEx,0,addr button,addr Dasm64,WS_VISIBLE or WS_CHILD,30,75,130,25,hWin,0,hInstance,0
		mov hShowList64,rax
		invoke CreateWindowEx,0,addr button,addr Clearing,WS_VISIBLE or WS_CHILD,30,105,130,25,hWin,0,hInstance,0
		mov hClear,rax
		invoke CreateWindowEx,0,addr edit,addr Mnem16,WS_VISIBLE or WS_TABSTOP or WS_CHILD or ES_LEFT,\
		165,15,700,25,hWin,0,hInstance,0
		mov hEdit16,rax
		invoke CreateWindowEx,0,addr edit,addr Mnem32,WS_VISIBLE or WS_TABSTOP or WS_CHILD or ES_LEFT,\
		165,45,700,25,hWin,0,hInstance,0
		mov hEdit32,rax
		invoke CreateWindowEx,0,addr edit,addr Mnem64,WS_VISIBLE or WS_TABSTOP or WS_CHILD or ES_LEFT,\
		165,75,700,25,hWin,0,hInstance,0
		mov hEdit64,rax
;		invoke CreateWindowEx,0,addr edit,addr Mnem64,WS_VISIBLE or WS_TABSTOP or WS_CHILD or ES_LEFT,\
;		165,105,700,25,hWin,0,hInstance,0
;		mov hSmm,rax
		invoke CreateWindowEx,0,addr edit,0,WS_VISIBLE or WS_TABSTOP or WS_CHILD or ES_LEFT or WS_HSCROLL or WS_VSCROLL or ES_MULTILINE,\
		30,60,900,450,hWin,0,hInstance,0
		mov hMainEdit,rax
		invoke GetClientRect,hWin,addr rects
		sub rects.bottom,150
		mov r10d,rects.bottom
		mov r9d,rects.right
		mov edx,rects.left
		invoke MoveWindow,hMainEdit,rdx,60,r9,r10,TRUE
		invoke CreateFontIndirect,addr lfFont
		mov hFont,rax
		invoke SendMessage,hMainEdit,WM_SETFONT,rax,TRUE
	.elseif edx==WM_SIZE
		invoke GetClientRect,hWin,addr rects
		sub rects.bottom,150
		mov r10d,rects.bottom
		mov r9d,rects.right
		mov edx,rects.left
		invoke MoveWindow,hMainEdit,rdx,150,r9,r10,TRUE
	.elseif edx==WM_DESTROY
		invoke PostQuitMessage,NULL
	.else
		leave
		jmp DefWindowProc
	.endif
	xor rax,rax
	ret
WndProc endp
breakpoint proc uses rcx rax rdx r8 r9 r10 r11
	call IsDebuggerPresent
	.if eax
		int 3
	.endif
	ret
breakpoint endp
AsmTest64 proc dMnemonic:PVOID,Mnemonic:PVOID
LOCAL hInstr:HINSTR
LOCAL AsmDasm[16]:BYTE,ilen:ULONG64
	mov dMnemonic,rcx
	mov Mnemonic,rdx
	invoke InitInstr,addr AsmDasm,StartAddr,LONG_MODE,sizeof AsmDasm
	mov hInstr,rax
	invoke Assemble,hInstr,Mnemonic
	mov ilen,rax
	.if ~eax || eax==-1
		invoke MessageBox,hWin,addr Error,0,MB_OK
		xor eax,eax
		ret
	.endif
	invoke JoinMnemonic,hInstr,dMnemonic,NULL,STD_MNEM
	invoke InstrEF,hInstr
	invoke EffRFlags,rax
	mov rax,hInstr
	movzx rax,[rax][Instruction.InstrLen]
	mov rax,ilen
	add StartAddr,rax
	invoke FreeInstr,hInstr
	mov eax,TRUE
	ret
AsmTest64 endp
AsmTest32 proc dMnemonic:PVOID,Mnemonic:PVOID
LOCAL hInstr:HINSTR
LOCAL AsmDasm[16]:BYTE,ilen:ULONG64
	mov dMnemonic,rcx
	mov Mnemonic,rdx
	invoke InitInstr,addr AsmDasm,StartAddr,LEGACY_MODE32,sizeof AsmDasm
	mov hInstr,rax
	invoke Assemble,hInstr,Mnemonic
	mov ilen,rax
	.if ~eax || eax==-1
		invoke MessageBox,hWin,addr Error,0,MB_OK
		xor eax,eax
		ret
	.endif
	invoke JoinMnemonic,hInstr,dMnemonic,NULL,STD_MNEM
	invoke InstrEF,hInstr
	invoke EffRFlags,rax
	mov rax,hInstr
	movzx rax,[rax][Instruction.InstrLen]
	mov rax,ilen
	add StartAddr,rax
	invoke FreeInstr,hInstr
	mov eax,TRUE
	ret
AsmTest32 endp
AsmTest16 proc dMnemonic:PVOID,Mnemonic:PVOID
LOCAL hInstr:HINSTR
LOCAL AsmDasm[16]:BYTE,ilen:ULONG64
	mov dMnemonic,rcx
	mov Mnemonic,rdx
	invoke InitInstr,addr AsmDasm,StartAddr,LEGACY_MODE16,sizeof AsmDasm
	mov hInstr,rax
	invoke Assemble,hInstr,Mnemonic
	mov ilen,rax
	.if ~eax || eax==-1
		invoke MessageBox,hWin,addr Error,0,MB_OK
		xor eax,eax
		ret
	.endif
	invoke JoinMnemonic,hInstr,dMnemonic,NULL,STD_MNEM
	invoke InstrEF,hInstr
	invoke EffRFlags,rax
	mov rax,hInstr
	movzx rax,[rax][Instruction.InstrLen]
	mov rax,ilen
	add StartAddr,rax
	invoke FreeInstr,hInstr
	mov eax,TRUE
	ret
AsmTest16 endp
EffRFlags proc ;pEF:PVOID
.const
sNA db '  NA'
s_0 db '  _0'
s_1 db '  _1'
slAH db ' lAH'
s_Mod db '_Mod'
sTMod db 'TMod'
s_Pop db '_Pop'
sTPop db 'TPop'
sTst db ' Tst'
sU db '   U'
.code
	test rcx,rcx
	mov ERFlags,0
	jz Exit
	lea rax,ERFlags
	lea r10,sNA
	mov r11,17
	.repeat
		.if r11==10
			mov byte ptr [rax],' '
			inc rax
		.endif
		movzx edx,byte ptr [rcx]
		inc rcx
		mov edx,[r10+4*rdx]
		mov [rax],edx
		mov byte ptr [rax][4],','
		add rax,5
		dec r11
	.until ZERO?
	mov dword ptr [rax-1],0A0Dh
Exit:
	ret
EffRFlags endp
end